RAID

Status

RAID5, which requires three or more disks, is running on Clitumno, and we've installed RAID1 (two-disk mirror) on Karamba.

Note that you could be using software RAID on other machines, to get the same redundant hard disks for disk failure protection!

Note that software RAID (MD) is likely faster than hardware RAID -- so you use a hardware RAID controller, but you run each disk individually and then group them through software RAID.

See also harddrives, clitunno, and the installation of software RAID on karamba.

Guides
Software
  • kernel
    • md (Multiple Device driver -- software RAID only, not needed for hardware RAID)
  • types of RAID
    • RAID0 -- striping (for speed)
    • RAID1 -- mirroring (for safety)
    • RAID4 and 5 -- "A RAID-5 set of N drives with a capacity of C MB per drive provides the capacity of C * (N - 1) MB, and protects against a failure of a single drive. For a given sector (row) number, (N - 1) drives contain data sectors, and one drive contains the parity protection. For a RAID-4 set, the parity blocks are present on a single drive, while a RAID-5 set distributes the parity across the drives in one of the available parity distribution methods."
    • RAID6 is still unstable -- avoid it
    • RAID10 -- combines 0 and 1 (?) -- new in 2.6.9
  • Debian
    • raidtools2 -- RAID admin tool (superceded by mdadm)
    • device mapper (dm) maintained by Red Hat -- check out their mailing list
    • raidutils -- for Adaptec I2O hardware
  • Other
init.d/3dmd scripts

From http://readlist.com/lists/lists.debian.org/debian-user/4/21085.html (August 2004)

#! /bin/sh
#
# 3dmd Start the 3dmd supplied by www.3ware.com
# Based on skeleton.
#
# Author: Andreas Neiser
#
set -e
PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
DAEMON=/usr/sbin/3dmd
NAME=3dmd
DESC="3ware Escalade daemon"
PIDFILE=/var/run/$NAME.pid
SCRIPTNAME=/etc/init.d/$NAME
# Gracefully exit if the package has been removed.
test -x $DAEMON || exit 0
case "$1" in
start)
echo -n "Starting $DESC: $NAME"
start-stop-daemon --start --quiet --oknodo \
--background --exec $DAEMON
echo "."
;;
stop)
echo -n "Stopping $DESC: $NAME"
start-stop-daemon --stop --quiet --oknodo \
--exec $DAEMON
echo "."
;;
restart|force-reload)
#
# If the "reload" option is implemented, move the
# "force-reload"
# option to the "reload" entry above. If not,
# "force-reload" is
# just the same as "restart".
#
echo -n "Restarting $DESC: $NAME"
start-stop-daemon --stop --quiet --oknodo \
--exec $DAEMON
sleep 1
start-stop-daemon --start --quiet --background --oknodo \
--exec $DAEMON
echo "."
;;
*)
# echo "Usage: $SCRIPTNAME
{start|stop|restart|reload|force-reload}" >&2
echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
exit 1
;;
esac


exit 0

Or this one, from http://iserv.nl/files/3dmd.init.debian:
#!/bin/sh
#
# $Id: 3dmd.init.d,v 1.0 2003/22/10 18:56:35 seth Exp $
#

# It is not safe to start if we don't have a default configuration...
if [ ! -f /etc/3dmd.conf ]; then
echo "/etc/3dmd.conf does not exist! - Aborting..."
exit 1
fi

3DMDPID=/var/run/3dmd.pid

case "$1" in
start)
echo -n "Starting 3dmd monitor: "
start-stop-daemon --start --quiet --pidfile $3DMDPID \
--exec /usr/sbin/3dmd
sleep 2

if [ -f "$3DMDPID" ] && ps h `cat "$3DMDPID"` >/dev/null; then
echo "3dmd."
else
echo "3dmd failed to start - check syslog for diagnostics."
fi
;;
stop)
echo -n "Stopping 3dmd monitor: 3dmd"
start-stop-daemon --stop --quiet --pidfile $3DMDPID
echo "."
;;
restart | force-reload)
$0 stop
sleep 2
$0 start
;;
*)
echo "Usage: /etc/init.d/3dmd {start|stop|restart|force-reload}"
exit 1
Installation history

On 20 September 2004, I downloaded the command-line interface tool to clitunno and issued
root@clitunno:/share/software/binary# ./tw_cli
3ware CLI> help

Copyright (c) 2003 3ware, Inc.  All rights reserved.
3ware CLI (version 2.00.00.032b)

Commands   Description
-------------------------------------------------------------------
info       Displays information about the controller
alarms     Displays or deletes the list of AENs
set        Displays or modifies controller settings
maint      Performs maintenance operations on a controller
quit       Exits the CLI

Type help <command> to get more details about a particular command.
"info" gives me "not compatible", so I likely need their driver, not the kernel's. Never mind.

There's a script called 3dm with a 3dmd daemon -- I didn't look for it.

 

 

CogWeb